// Determine wether of not coverage preprocessor should be used
var gutil = require('gulp-util'),
    isCoverageMode = gutil.env.hasOwnProperty('coverage');

// Karma configuration
// Generated on Thu Aug 04 2016 14:03:14 GMT+0200 (CEST)

module.exports = function(config) {
    config.set({

        // base path that will be used to resolve all patterns (eg. files, exclude)
        basePath: '',


        // frameworks to use
        // available frameworks: https://npmjs.org/browse/keyword/karma-adapter
        frameworks: ['jasmine', 'chai', 'sinon', 'chai-sinon'],


        // list of files / patterns to load in the browser
        files: [
            'public/js/bower_components.min.js',
            'bower_components/bardjs/dist/bard.js',
            'bower_components/bardjs/dist/bard-ngRouteTester.js',
            'assets/app/**/*.module.js',
            'assets/app/**/*.js',
            'public/app/crowbar-app.templates.js'
        ],


        // list of files to exclude
        exclude: [
        ],


        // preprocess matching files before serving them to the browser
        // available preprocessors: https://npmjs.org/browse/keyword/karma-preprocessor
        preprocessors: {
        },

        // optionally, configure the reporter
        coverageReporter: {
            type : 'html',
            dir : 'coverage/',
            check: {
                global: {
                    statements: 80,
                    branches: 80,
                    functions: 80,
                    lines: 80
                }
            },
            includeAllSources: true,
            reporters:[
                {type: 'html', dir:'coverage/'},
                {type: 'text-summary'}
            ],
            instrumenterOptions: {
                istanbul: { noCompact: true }
            }
        },

        // test results reporter to use
        // possible values: 'dots', 'progress'
        // available reporters: https://npmjs.org/browse/keyword/karma-reporter
        reporters: ['progress'],


        // web server port
        port: 9876,


        // enable / disable colors in the output (reporters and logs)
        colors: true,


        // level of logging
        // possible values:
        //      config.LOG_DISABLE || config.LOG_ERROR || config.LOG_WARN || config.LOG_INFO || config.LOG_DEBUG
        logLevel: config.LOG_INFO,


        // enable / disable watching file and executing tests whenever any file changes
        autoWatch: true,


        // start these browsers
        // available browser launchers: https://npmjs.org/browse/keyword/karma-launcher
        browsers: ['PhantomJS'],


        // Continuous Integration mode
        // if true, Karma captures browsers, runs the tests and exits
        singleRun: false,

        // Concurrency level
        // how many browser should be started simultaneous
        concurrency: Infinity
    });


    // Coverage report will be generated
    if (isCoverageMode) {
        config.set({
            preprocessors: {
                // source files, that you wanna generate coverage for
                // do not include tests or libraries
                // (these files will be instrumented by Istanbul)
                'assets/app/**/*.js': ['coverage']
            },

            // optionally, configure the reporter
            coverageReporter: {
                type : 'html',
                dir : 'coverage/',
                check: {
                    global: {
                        statements: 80,
                        branches: 80,
                        functions: 80,
                        lines: 80
                    }
                },
                includeAllSources: true,
                reporters:[
                    {type: 'html', dir:'coverage/'},
                    {type: 'text-summary'}
                ],
                instrumenterOptions: {
                    istanbul: { noCompact: true }
                }
            },

            // test results reporter to use
            // possible values: 'dots', 'progress'
            // available reporters: https://npmjs.org/browse/keyword/karma-reporter
            reporters: ['progress', 'coverage']

        });

    }
}
